Crystal::SyntaxHighlighter::Colorize - Crystal 1.6.0

# class Crystal::SyntaxHighlighter::Colorize

- Crystal::SyntaxHighlighter::Colorize
- Crystal::SyntaxHighlighter
- Reference
- Object

##
Overview

A syntax highlighter that renders Crystal source code with ANSI escape codes suitable for terminal highlighting.

    code = %(foo = bar("baz\#{PI + 1}") # comment)
    colorized = Crystal::SyntaxHighlighter::Colorize.highlight(code)
    colorized # => "foo \e[91m=\e[0m bar(\e[93m\"baz\#{\e[0;36mPI\e[0;93m \e[0;91m+\e[0;93m \e[0;35m1\e[0;93m}\"\e[0m) \e[90m# comment\e[0m"

##
Defined in:

crystal/syntax_highlighter/colorize.cr

##
Constructors

- .new(io : IO, colorize : ::Colorize::Object(String) = ::Colorize.with.toggle(true))

  Creates a new instance of a Colorize syntax highlighter.

##
Class Method Summary

- .highlight(io : IO, code : String)

  Highlights code and writes the result to io.

- .highlight(code : String)

  Highlights code and returns the result.

- .highlight!(code : String)

  Highlights code or returns unhighlighted code on error.

##
Instance Method Summary

- #colors : Hash(TokenType, ::Colorize::Color)
- #colors=(colors : Hash(TokenType, ::Colorize::Color))
- #render(type : TokenType, value : String)

  Renders token with text value.

- #render_delimiter(&)

  Renders a delimiter sequence.

- #render_interpolation(&)

  Renders an interpolation sequence.

- #render_string_array(&)

  Renders a string array sequence.

### Instance methods inherited from class `Crystal::SyntaxHighlighter`

highlight(code : String) highlight, render(type : TokenType, value : String) render, render_delimiter(&) render_delimiter, render_interpolation(&) render_interpolation, render_string_array(&) render_string_array

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(io : IO, colorize : ::Colorize::Object(String) = ::Colorize.with.toggle(true)) #

Creates a new instance of a Colorize syntax highlighter.

Appends highlighted output (when calling `#highlight`) to io.

##
Class Method Detail

def self.highlight(io : IO, code : String) #

Highlights code and writes the result to io.

def self.highlight(code : String) #

Highlights code and returns the result.

def self.highlight!(code : String) #

Highlights code or returns unhighlighted code on error.

Same as `.highlight(code : String)` except that any error is rescued and returns unhighlighted source code.

##
Instance Method Detail

def colors : Hash(TokenType, ::Colorize::Color) #
def colors=(colors : Hash(TokenType, ::Colorize::Color)) #
def render(type : TokenType, value : String) #
Description copied from class Crystal::SyntaxHighlighter

Renders token with text value.

def render_delimiter(&) #
Description copied from class Crystal::SyntaxHighlighter

Renders a delimiter sequence.

def render_interpolation(&) #
Description copied from class Crystal::SyntaxHighlighter

Renders an interpolation sequence.

def render_string_array(&) #
Description copied from class Crystal::SyntaxHighlighter

Renders a string array sequence.